#COMPILE EXE
#DIM ALL
#INCLUDE "WIN32API.INC"
'#INCLUDE "debug.inc"
#RESOURCE "calendar.pbr"

$Ver = "2.00"
'This version uses Windows API for all of the displaying (tablet compatibility)

DECLARE SUB calendar()
DECLARE CALLBACK FUNCTION calendarProc()
DECLARE SUB initCalendar()
DECLARE SUB showMonths(BYVAL LONG, BYVAL LONG)
DECLARE SUB showText(LONG, LONG, LONG, STRING)
DECLARE FUNCTION daysInMonth(LONG, LONG) AS LONG
DECLARE FUNCTION dayOfWeek(LONG, LONG, LONG) AS LONG
DECLARE FUNCTION MakeFont(LONG, STRING, BYVAL LONG, OPT BYVAL STRING) AS LONG


%IDC_DecrYr = 101
%IDC_DecrMo = 102
%IDC_IncrMo = 103
%IDC_IncrYr = 104

GLOBAL hCal, hdc, hfont, hfont1 AS LONG
GLOBAL today, thisMo, thisYr AS LONG
global xWeek, xchr, ychr, wi, ht as long

FUNCTION PBMAIN
   calendar
END FUNCTION

SUB calendar
   LOCAL STYLE AS LONG
   DIALOG NEW PIXELS, 0, "Calendar", , , 760, 360, %WS_SYSMENU TO hCal
   DIALOG SET COLOR hCal, -1, %WHITE
   STYLE = %BS_DEFAULT OR %WS_TABSTOP
   CONTROL ADD BUTTON, hCal, %IDCANCEL, "Cancel", 550, 280, 100, 40, STYLE
   CONTROL ADD BUTTON, hCal, %IDC_DecrYr, "<<  Year", 30, 280, 90, 40
   CONTROL ADD BUTTON, hCal, %IDC_DecrMo, "<  Month", 122, 280, 90, 40
   CONTROL ADD BUTTON, hCal, %IDC_IncrMo, "Month  >", 214, 280, 90, 40
   CONTROL ADD BUTTON, hCal, %IDC_IncrYr, "Year  >>", 306, 280, 90, 40
   DIALOG SHOW MODAL hCal CALL calendarProc
END SUB

CALLBACK FUNCTION calendarProc
   LOCAL ti AS STRING, ps AS PAINTSTRUCT
   STATIC mo AS LONG, yr AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         mo = VAL(LEFT$(DATE$, 2))
         yr = VAL(RIGHT$(DATE$, 4))
         today = VAL(MID$(DATE$, 4, 2))
         thisMo = mo: thisYr = yr: DECR mo
         IF mo = 0 THEN mo = 12: DECR yr
      CASE %WM_paint 'show dialog for first time
         BeginPaint CBHNDL, ps
         initCalendar
         showCalendar mo, yr
         EndPaint CBHNDL, ps
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_DecrYr
               DECR yr
               InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE %IDC_DecrMo
               DECR mo: IF mo < 1 THEN mo = 12: DECR yr
               InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE %IDC_IncrMo
               INCR mo: IF mo > 12 THEN mo = 1: INCR yr
               InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE %IDC_IncrYr
               INCR yr
               InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE %IDCANCEL
               IF thisMo = 1 THEN mo = 0: INCR yr
               IF mo = thisMo - 1 AND yr = thisYr THEN
                  DIALOG END CBHNDL
               ELSE
                  mo = thisMo - 1: yr = thisYr
                  IF mo = 0 THEN mo = 12: DECR yr
                  InvalidateRect CBHNDL, BYVAL %NULL, 1
               END IF
         END SELECT
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
   END SELECT
END FUNCTION

sub initCalendar()
   local t AS SIZEL, sz AS ASCIIZ * 128
   hdc = GetDC(hCal)
   hFont = makeFont(hdc, "Courier New", 10)
   hFont1 = makeFont(hdc, "MS Sans Serif", 12)
   SelectObject hdc, hFont
   sz = "Sun Mon Tue Wed Thu Fri Sat"
   GetTextExtentPoint32 hdc, sz, LEN(sz), t
   xchr = (t.cx/27.0)+0.5: ychr = 1.5*t.cy
   xWeek = cdbl(t.cx)+.5
   wi = 3*xWeek + 14*xchr: ht = 16*ychr
   dialog set size hCal, wi, ht
end sub

SUB showCalendar(BYVAL mo AS LONG, BYVAL yr AS LONG)
   LOCAL i, j, m, n, x00, savmo, savyr AS LONG
   LOCAL startDay, days, k1, k2, xBottom, yBottom AS LONG
   LOCAL s, ss, ti AS STRING, t AS SIZEL, sz AS ASCIIZ * 128
   LOCAL memdc, hBit, x, y, moYrLen, moYrLen0 AS LONG
   DIM months(12) AS STRING
   months(1) = "January" : months(2) = "February" : months(3) = "March"
   months(4) = "April"   : months(5) = "May"      : months(6) = "June"
   months(7) = "July"    : months(8) = "August"   : months(9) = "September"
   months(10)= "October" : months(11)= "November" : months(12)= "December"
   savmo = mo: savyr = yr
   'hdc = GetDC(hCal)
   'hBit = LoadBitmap(GetModuleHandle(BYVAL %NULL), "TodayBitMap")
   'hFont = makeFont(hdc, "Courier New", 10)
   'hFont1 = makeFont(hdc, "MS Sans Serif", 12)
   'SelectObject hdc, hFont1

   'show month and year titles
   SelectObject hdc, hFont1
   SetTextColor hdc, %WHITE
   SetBkColor hdc, RGB(128, 128, 255)
   sz = SPACE$(42): GetTextExtentPoint32 hdc, sz, LEN(sz), t
   moYrLen0 = cdbl(t.cx)+.5: ss = "Today"
   s = months(mo) + STR$(yr): sz = s
   GetTextExtentPoint32 hdc, sz, LEN(sz), t
   FOR i = 0 TO 2
      x00 = (xWeek+4*xchr) * i
      x = 2*xchr + x00 + (xWeek - moYrLen0)/2: y = .5*t.cy 
      showText hdc, x, y, SPACE$(42)
      sz = months(mo) + STR$(yr): s = sz
      GetTextExtentPoint32 hdc, sz, LEN(sz), t
      moYrLen = cdbl(t.cx)+.5
      showText hdc, x + (moYrLen0-moYrLen)/2, y, s
      INCR mo: IF mo > 12 THEN mo = 1: INCR yr
   NEXT i

   'show week days label, draw lines
   SelectObject hdc, hFont
   SetTextColor hdc, %BLACK
   SetBkColor hdc, %WHITE
   sz = "Sun Mon Tue Wed Thu Fri Sat": ti = sz
   GetTextExtentPoint32 hdc, sz, LEN(sz), t
   xchr = (t.cx/27.0)+0.5: ychr = t.cy
   xWeek = cdbl(t.cx)+.5: yBottom = 13.5*ychr
   FOR i = 0 TO 2 
      x00 = (xWeek+4*xchr) * i
      showText hdc, 2*xchr + x00, 40, ti
      MoveToEx hDC, 1.5*xchr+x00, 60, BYVAL %NULL
      LineTo hDC, xWeek+2.5*xchr + x00, 60
      IF i > 0 THEN 'draw vert lines
         MoveToEx hDC, x00, 20, BYVAL %NULL
         LineTo hDC, x00, yBottom
      END IF
   NEXT i
   xBottom = 3*xWeek + 12*xchr
   MoveToEx hDC, xchr, yBottom, BYVAL %NULL
   LineTo hDC, xBottom, yBottom
   
   'fill in the days of the month and circle today's date
   mo = savmo: yr = savyr
   hBit = LoadBitmap(GetModuleHandle(BYVAL %NULL), "TodayBitMap")
   FOR i = 0 TO 2
      startDay = dayOfWeek(mo, yr, 1)
      days = daysInMonth(mo, yr)
      m = 1: n = startDay
      x00 = (xWeek+4*xchr) * i
      FOR j = 1 TO days
         s = RIGHT$(" " + STR$(j), 2): k1 = %BLACK: k2 = %WHITE
         x = x00+3*xchr + 4*xchr*n: y = 3*ychr + 1.5*ychr*m
         showText hDC, x, y, s  'display the days in the month
         IF j = today AND mo = thisMo AND yr = thisYr THEN 'circle today's date
            memdc = CreateCompatibleDC(hdc)
            SelectObject memdc, hBit
            BitBlt hdc, x-3, y-3, 32, 32, memdc, 0, 0, %SRCAND
            DeleteDC memdc
            IF i = 1 THEN ss = "Cancel"
         END IF
         INCR n: IF n MOD 7 = 0 THEN INCR m: n = 0
      NEXT j
      INCR mo: IF mo > 12 THEN mo = 1: INCR yr
   NEXT i
   CONTROL SET TEXT hCal, %IDCANCEL, ss
   DeleteObject hBit
   ReleaseDC hCal, hdc
END SUB

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION

FUNCTION dayOfWeek(mo AS LONG, yr AS LONG, day AS LONG) AS LONG
   'Sun=0, Mon=1, Tue=2,... Sat=6
   LOCAL n AS INTEGER
   n = yr - 1899 + (yr - 1901) \ 4
   IF mo < 8 THEN
      n = n + 30 * (mo - 1) + mo \ 2
   ELSE
      n = n + 30 * (mo - 1) + (mo + 1) \ 2
   END IF
   IF mo > 2 THEN
      n = n - 2
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN IF mo > 2 THEN INCR n 'leap yr
   END IF
   FUNCTION = (n + day - 1) MOD 7
END FUNCTION

SUB showText(hDC AS LONG, x AS LONG, y AS LONG, TXT AS STRING)
   TextOut hDC, x, y, BYVAL STRPTR(TXT), LEN(TXT)
END SUB

FUNCTION MakeFont(hDC AS LONG, sFont AS STRING, BYVAL ptSize AS LONG, _
                  OPT BYVAL descr AS STRING) AS LONG
   'specify descr = b for bold, u for underline, i for italic
   LOCAL CyPixels AS LONG, charHt AS LONG, wt AS DWORD
   LOCAL BOLD AS DWORD, underline AS DWORD, italic AS DWORD
   IF LEN(descr) THEN
      BOLD = INSTR(descr, "b") + 300
      underline = INSTR(descr,"u")
      italic = INSTR(descr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (PtSize * CyPixels) \ 72
   wt = %FW_NORMAL + BOLD
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION
